'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _jsonStableStringify = require('json-stable-stringify');

var _jsonStableStringify2 = _interopRequireDefault(_jsonStableStringify);

var _isomorphicMapzenSearch = require('isomorphic-mapzen-search');

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _throttle = require('lodash/throttle');

var _throttle2 = _interopRequireDefault(_throttle);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GEOLOCATE_VALUE = 'geolocate';

var Geocoder = function (_Component) {
  (0, _inherits3.default)(Geocoder, _Component);

  function Geocoder() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Geocoder);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Geocoder.__proto__ || (0, _getPrototypeOf2.default)(Geocoder)).call.apply(_ref, [this].concat(args))), _this), _this.autocompleteCache = {}, _this.options = {}, _this.state = {
      options: _this.defaultOptions(),
      value: _this.props.value || null
    }, _this.featureToOption = function (feature) {
      var _this$props = _this.props,
          featureToLabel = _this$props.featureToLabel,
          featureToValue = _this$props.featureToValue;

      return {
        feature: feature,
        label: featureToLabel(feature),
        value: featureToValue(feature)
      };
    }, _this.loadOptions = function (input, callback) {
      var _this$props2 = _this.props,
          apiKey = _this$props2.apiKey,
          boundary = _this$props2.boundary,
          focusPoint = _this$props2.focusPoint,
          geolocate = _this$props2.geolocate,
          search = _this$props2.search;

      if (!input) {
        if (geolocate && 'geolocation' in navigator) {
          callback(null, {
            options: _this.defaultOptions()
          });
        } else {
          callback(null);
        }
      } else {
        var autocompleteQuery = {
          apiKey: apiKey,
          boundary: boundary,
          focusPoint: focusPoint,
          text: input
        };
        var autocompleteQueryKey = (0, _jsonStableStringify2.default)(autocompleteQuery);

        // check if autocomplete query has been made before
        var cacheValue = _this.autocompleteCache[autocompleteQueryKey];
        if (cacheValue) {
          return callback(null, cacheValue);
        }

        search(autocompleteQuery).then(function (geojson) {
          var options = geojson && geojson.features ? geojson.features.map(_this.featureToOption) : [];
          _this.cacheOptions(options);
          _this.autocompleteCache[autocompleteQueryKey] = { options: options };
          callback(null, { options: options });
        }).catch(function (error) {
          callback(error);
        });
      }
    }, _this._onChange = function (value) {
      var _this$props3 = _this.props,
          apiKey = _this$props3.apiKey,
          findingLocationText = _this$props3.findingLocationText,
          onChange = _this$props3.onChange,
          reverseSearch = _this$props3.reverseSearch;

      if (value && value.value === GEOLOCATE_VALUE) {
        _this.setState((0, _extends3.default)({}, _this.state, {
          value: {
            label: findingLocationText
          }
        }));
        window.navigator.geolocation.getCurrentPosition(function (position) {
          reverseSearch({
            apiKey: apiKey,
            point: position.coords
          }).then(function (geojson) {
            var value = _this.featureToOption(geojson.features[0]);
            _this.setState((0, _extends3.default)({}, _this.state, {
              value: value
            }));
            onChange && onChange(value);
          }).catch(function (err) {
            console.error('Error during reverse lookup of', position);
            console.error(err);
            var value = _this.featureToOption({
              type: 'Feature',
              properties: {
                label: position.longitude + ', ' + position.latitude
              },
              geometry: {
                type: 'Point',
                coordinates: [position.longitude, position.latitude]
              }
            });
            _this.setState((0, _extends3.default)({}, _this.state, {
              value: value
            }));
            onChange && onChange(value);
          });
        });
      } else {
        if (!value) {
          _this.setState({
            options: _this.defaultOptions(),
            value: value
          });
        } else {
          _this.setState({ value: value });
        }
        _this.props.onChange && _this.props.onChange(value && _this.options[value.value]);
      }
    }, _this._saveRef = function (select) {
      _this.select = select;
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Geocoder, [{
    key: 'cacheOptions',
    value: function cacheOptions(options) {
      var _this2 = this;

      options.forEach(function (o) {
        _this2.options[o.value] = o.feature;
      });
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this._throttledLoadOptions = (0, _throttle2.default)(this.loadOptions, this.props.rateLimit || 500);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2.default)(nextProps.value, this.props.value)) {
        this.setState({ value: nextProps.value });
      }

      if (this.props.rateLimit !== nextProps.rateLimit) {
        this._throttledLoadOptions = (0, _throttle2.default)(this.loadOptions, this.props.rateLimit || 500);
      }
    }
  }, {
    key: 'defaultOptions',
    value: function defaultOptions() {
      return this.props.geolocate && 'geolocation' in navigator ? [{ label: this.props.useLocationText, value: GEOLOCATE_VALUE }] : [];
    }
  }, {
    key: 'focus',
    value: function focus() {
      this.select.focus();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_reactSelect2.default.Async, (0, _extends3.default)({
        autoBlur: true,
        autoload: false,
        cache: false,
        filterOptions: false,
        ignoreAccents: false,
        ignoreCase: false,
        loadOptions: this._throttledLoadOptions,
        minimumInput: 3,
        options: this.state.options
      }, this.props, {
        onChange: this._onChange,
        ref: this._saveRef,
        value: this.state.value,
        onBlurResetsInput: false
      }));
    }
  }]);
  return Geocoder;
}(_react.Component);

Geocoder.propTypes = {
  apiKey: _propTypes2.default.string.isRequired,
  boundary: _propTypes2.default.object,
  featureToLabel: _propTypes2.default.func,
  featureToValue: _propTypes2.default.func,
  findingLocationText: _propTypes2.default.string,
  focusPoint: _propTypes2.default.any,
  geolocate: _propTypes2.default.bool,
  onChange: _propTypes2.default.func,
  placeholder: _propTypes2.default.string,
  rateLimit: _propTypes2.default.number,
  reverseSearch: _propTypes2.default.func,
  search: _propTypes2.default.func,
  useLocationText: _propTypes2.default.string,
  value: _propTypes2.default.object
};
Geocoder.defaultProps = {
  featureToLabel: function featureToLabel(feature) {
    return feature.properties.label;
  },
  featureToValue: function featureToValue(feature) {
    return feature.properties.label + '-' + feature.geometry.coordinates.join(',');
  },
  findingLocationText: 'Locating you...',
  reverseSearch: _isomorphicMapzenSearch.reverse,
  search: _isomorphicMapzenSearch.autocomplete,
  useLocationText: 'Use Current Location'
};


module.exports = Geocoder;

//# sourceMappingURL=index.js